package PlayTravel.Activity;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import PlayTravel.Activity.ModifyAlbum.PatchInputStream;
import PlayTravel.Data.Category;
import PlayTravel.Data.Theme;
import PlayTravel.Database.DB;
import android.app.Activity;
import android.app.AlertDialog;
import android.app.DatePickerDialog;
import android.app.Dialog;
import android.app.ProgressDialog;
import android.app.AlertDialog.Builder;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.res.Resources;
import android.database.Cursor;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.drawable.BitmapDrawable;
import android.hardware.Camera;
import android.hardware.Camera.Size;
import android.net.Uri;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.provider.MediaStore;
import android.provider.SyncStateContract.Constants;
import android.text.format.Time;
import android.util.Log;
import android.view.MenuItem;
import android.view.SurfaceHolder;
import android.view.SurfaceView;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.FrameLayout;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.RadioGroup;
import android.widget.Spinner;
import android.widget.Toast;
import android.widget.RadioGroup.OnCheckedChangeListener;

public class WriteAlbum extends Activity implements OnClickListener{
	private Intent intent;
	private DB dbCon;	
	ArrayList<Category> category = null;	
	private ArrayAdapter<String> adapter = null;
	private Integer lastAlbumID = 0;
	private ImageView img_1 = null;
	private ImageView img_2 = null;
	private ImageView img_3 = null;
	private ImageView img_4 = null;
	private ImageView img_5 = null;
	private ImageView img_1_back = null;
	private ImageView img_2_back = null;
	private ImageView img_3_back = null;
	private ImageView img_4_back = null;
	private ImageView img_5_back = null;
	private ImageView nowImgView = null;
	private Button getLocation = null;
	private ImageView wasteBasket = null;
	
	private String address = null;
	private Double x = null;
	private Double y = null;
	private String local = null;
	private ArrayList<String> imgs = null;
	
	private ProgressDialog dialog;
	
	private String comment;
	private Integer selectedId;
	private Integer modifyIndex = 0;
	
	private Bitmap bits[] = null;
	private Bitmap nonImage = null;
	private Bitmap nonSmallImage = null;
	private Bitmap bit = null;
	
	@Override
	protected void onCreate(Bundle savedInstanceState) {
		// TODO Auto-generated method stub
		super.onCreate(savedInstanceState);
		setContentView(R.layout.writealbum);
		findViewById(R.id.writealbum_home).setOnClickListener(this);
		findViewById(R.id.saveBtn).setOnClickListener(this);
		findViewById(R.id.captureBtn).setOnClickListener(this);
		findViewById(R.id.selBtn).setOnClickListener(this);
		final Spinner spin = (Spinner) findViewById(R.id.category);
		getLocation = (Button) findViewById(R.id.getLocation);
		getLocation.setOnClickListener(this);
		nowImgView = (ImageView) findViewById(R.id.nowImg2);
		
		img_1 = (ImageView) findViewById(R.id.img_1);
		img_2 = (ImageView) findViewById(R.id.img_2);
		img_3 = (ImageView) findViewById(R.id.img_3);
		img_4 = (ImageView) findViewById(R.id.img_4);
		img_5 = (ImageView) findViewById(R.id.img_5);
		img_1_back = (ImageView) findViewById(R.id.img_1_back);
		img_2_back = (ImageView) findViewById(R.id.img_2_back);
		img_3_back = (ImageView) findViewById(R.id.img_3_back);
		img_4_back = (ImageView) findViewById(R.id.img_4_back);
		img_5_back = (ImageView) findViewById(R.id.img_5_back);
		wasteBasket = (ImageView) findViewById(R.id.wastebasket);
		
		
		nonImage = BitmapFactory.decodeResource(getResources(), R.drawable.blank_image);
		nonSmallImage = BitmapFactory.decodeResource(getResources(), R.drawable.blank_small);
		
		bits = new Bitmap[5];
		
		img_1.setOnClickListener(this);
		img_2.setOnClickListener(this);
		img_3.setOnClickListener(this);
		img_4.setOnClickListener(this);
		img_5.setOnClickListener(this);
		img_1_back.setOnClickListener(this);
		img_2_back.setOnClickListener(this);
		img_3_back.setOnClickListener(this);
		img_4_back.setOnClickListener(this);
		img_5_back.setOnClickListener(this);
		nowImgView.setOnClickListener(this);
		wasteBasket.setOnClickListener(this);
	
		
		imgs  = new ArrayList<String>();		
		dbCon = new DB();
		category = dbCon.getCategoryList();  
		lastAlbumID = Integer.parseInt(dbCon.getLastAlbumID());
		
		ArrayList<String> items = null;
		items = new ArrayList<String>();
		
		for (Integer i = 0 ; i < 5 ; i++)
		{
			bits[i] = nonImage;
			imgs.add("");
		}
		
		for (Integer i = 0 ; i < category.size() ;i++)
		{
			items.add(category.get(i).getName());			
		}
		
		adapter = new ArrayAdapter<String>(this,android.R.layout.simple_spinner_item,items);
		adapter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		spin.setAdapter(adapter);	
		
		changeBackImg(0);		
	}
	
	@Override
	protected void onRestart() {
		// TODO Auto-generated method stub
		super.onRestart();
	}
	@Override
	protected void onStart() {
		// TODO Auto-generated method stub
		super.onStart();
	}
	@Override
	protected void onResume() {
		// TODO Auto-generated method stub
		super.onResume();		
	}//
	
	 @Override
		protected void onActivityResult(int requestCode, int resultCode, Intent data){
			super.onActivityResult(requestCode, resultCode, data);;
			if(resultCode==RESULT_OK)
			{
				if(requestCode==1)
				{
					try{							
						//Bitmap bit = (Bitmap) data.getExtras().get("data");
						
						BitmapFactory.Options options = new BitmapFactory.Options();
				         options.inSampleSize =4; //̹ ö 1/8 ũ .
				         Bitmap bit = BitmapFactory.decodeFile("/sdcard/playtravel/temp.jpg",options);
												
						String imgName = "";
						Long tmpCal = null;
						Calendar cal = Calendar.getInstance();
						tmpCal = cal.getTimeInMillis();
						imgName = tmpCal.toString() + ".jpg";
						
						String FILE_ROOT = "/sdcard/";
	                	String dirName = "playtravel";
	                	String fullSrc = FILE_ROOT + dirName + "/" + imgName;    	                	
	                	
	                	File directory = new File(FILE_ROOT + dirName + "/");                     	
                    	
                    	
                    	if (directory.exists() == false)
                    	{
                    		directory.mkdir();                        	
                    	}                    	
                    	
                    	FileOutputStream fos;                        	                            
                        fos = new FileOutputStream(fullSrc);
                        bit.compress(Bitmap.CompressFormat.JPEG, 100, fos);
                        fos.close();                         
                        	
						
						switch(modifyIndex)
						{
							case 0 : 
								img_1.setImageBitmap(bit);
								break;
							case 1 : 
								img_2.setImageBitmap(bit);
								break;
							case 2 : 
								img_3.setImageBitmap(bit);
								break;
							case 3 : 
								img_4.setImageBitmap(bit);
								break;
							case 4 : 
								img_5.setImageBitmap(bit);
								break;
						}
									
						nowImgView.setImageBitmap(bit);							
						
						changeBackImg(modifyIndex);
						bits[modifyIndex] = bit;
						imgs.set(modifyIndex, fullSrc);
				       
						
					}catch (Exception e) {
						// TODO: handle exception
					}
					
				}
				else if(requestCode==2)
				{					
					address = (String) data.getStringExtra("address");
					x = data.getDoubleExtra("x", 0);
					y = data.getDoubleExtra("y", 0);
					local = (String) data.getStringExtra("local");
					String tmpStr = null;
					try{
						tmpStr = address.substring(0,20) + "...";
					}catch(Exception e){
						tmpStr = address;
					}
					getLocation.setText(tmpStr);
				}
				else if(requestCode==3)
				{
					try{
						Uri curImgURI = data.getData(); 
						String tmpSrc = this.getPath(curImgURI); 
						
						BitmapFactory.Options options = new BitmapFactory.Options();
						options.inSampleSize = 4;
						bit = BitmapFactory.decodeFile(tmpSrc, options);
						
						switch(modifyIndex)
						{
							case 0 : 
								img_1.setImageBitmap(bit);
								break;
							case 1 : 
								img_2.setImageBitmap(bit);
								break;
							case 2 : 
								img_3.setImageBitmap(bit);
								break;
							case 3 : 
								img_4.setImageBitmap(bit);
								break;
							case 4 : 
								img_5.setImageBitmap(bit);
								break;
						}
						
						
						nowImgView.setImageBitmap(bit);	
						bits[modifyIndex] = bit;						
						changeBackImg(modifyIndex);
						imgs.set(modifyIndex, tmpSrc);
					}catch (Exception e) {
						// TODO: handle exception
					}
					
				}
			}
		}
	 
	@Override
	protected void onPause() {
		// TODO Auto-generated method stub
		super.onPause();
	}

	@Override
	protected void onStop() {
		// TODO Auto-generated method stub
		super.onStop();
	}
	@Override
	protected void onDestroy() {
		// TODO Auto-generated method stub
		super.onDestroy();
		
		try{
			for (Integer i = 0 ; i < 5 ; i++)
			{
				bits[i].recycle();
			}
			
			bit.recycle();
		}catch(Exception e) {
			// TODO: handle exception
		}
		
		
		
	}
	@Override
	public void onClick(View v) {
		// TODO Auto-generated method stub
		Uri pictureUri;
		
		switch(v.getId())
		{
			case R.id.captureBtn :		
				
				String FILE_ROOT = "/sdcard/";
            	String dirName = "playtravel"; 	                	
            	
            	File directory = new File(FILE_ROOT + dirName + "/");                     	
            	
            	
            	if (directory.exists() == false)
            	{
            		directory.mkdir();                        	
            	}              
            	
				pictureUri = Uri.fromFile(new File("/sdcard/playtravel/temp.jpg")); 
				
				intent = new Intent(android.provider.MediaStore.ACTION_IMAGE_CAPTURE);
				intent.putExtra(MediaStore.EXTRA_OUTPUT, pictureUri); 
				startActivityForResult(intent,1);				
					
			break;			
			case R.id.writealbum_home :
				intent = new Intent(WriteAlbum.this,Main.class);
				startActivity(intent);
				finish();
				break;
			case R.id.getLocation :
				intent = new Intent(WriteAlbum.this,MyLocationSetting.class);
				startActivityForResult(intent,2);
				break;
			case R.id.saveBtn:				
				checkInfo();
			break;	
			case R.id.selBtn:
				intent = new Intent(); 
                intent.setType("image/*"); 
                intent.setAction(Intent.ACTION_GET_CONTENT); 
                startActivityForResult(Intent.createChooser(intent, 
                        "Select Picture"), 3); 

			break;
			
			case R.id.img_1:	
				changeImg(0);
			break;	
			case R.id.img_2:	
				changeImg(1);
			break;	
			case R.id.img_3:
				changeImg(2);
			break;	
			case R.id.img_4:
				changeImg(3);
			break;	
			case R.id.img_5:
				changeImg(4);
			break;			
			case R.id.wastebasket:
				deleteImage();
			break;
		}		
	}
	
	private void deleteImage()
	{
		if (imgs.get(modifyIndex).equals("")) return ;		
		
		showDialog(0);
	}
	
	private void setNonImage(Integer index)
	{
		switch(index)
		{
			case 0:
				img_1.setImageBitmap(nonSmallImage);
			break;	
			case 1:	
				img_2.setImageBitmap(nonSmallImage);
			break;	
			case 2:
				img_3.setImageBitmap(nonSmallImage);
			break;	
			case 3:
				img_4.setImageBitmap(nonSmallImage);
			break;	
			case 4:
				img_5.setImageBitmap(nonSmallImage);
			break;	
		}
		
		nowImgView.setImageBitmap(nonImage);
		
		imgs.set(modifyIndex,"");	
		bits[modifyIndex].recycle();
		bits[modifyIndex] = null;
	}
	
	@Override
    protected Dialog onCreateDialog(int id) {
		Builder di;
		switch (id) 
		{
	        case 0:
	            // This example shows how to add a custom layout to an AlertDialog
	            di =  new AlertDialog.Builder(WriteAlbum.this);
	            di.setTitle("Warning");
	            di.setMessage(" ðڽϱ?");
	            di.setPositiveButton("Ok", new DialogInterface.OnClickListener() {
	                public void onClick(DialogInterface dialog, int whichButton) {	
	                    /* User clicked OK so do some stuff */                	
	                	setNonImage(modifyIndex);
	                }
	            });
	            di.setNegativeButton("Cancel", new DialogInterface.OnClickListener() {
	                public void onClick(DialogInterface dialog, int whichButton) {
	                    /* User clicked Cancel so do some stuff */
	                }
	            });
	            return di.create();
		}
		return null;
	}
	
	private Integer getImageCount()
	{
		Integer count = 0;
		
		if (imgs == null) return 0;	
		
		for (Integer i = 0 ; i < imgs.size() ; i++)
		{
			if (!imgs.get(i).equals(""))
				count++;
		}	
		
		return count;
	}
	
	public void changeImg(Integer index)
	{		
		try{
			
			modifyIndex = index;
			
			nowImgView.setImageBitmap(bits[modifyIndex]);	
			
			changeBackImg(index);
		}catch (Exception e) {
			// TODO: handle exception
		}
	}
	
	public void changeBackImg(Integer index)
	{
		try{
			
			for (Integer i = 0 ; i < 5 ; i++)
			{
				switch(i)
				{
					case 0 : 
						img_1_back.setBackgroundColor(Color.WHITE);
						break;
					case 1 : 
						img_2_back.setBackgroundColor(Color.WHITE);
						break;
					case 2 : 
						img_3_back.setBackgroundColor(Color.WHITE);
						break;
					case 3 : 
						img_4_back.setBackgroundColor(Color.WHITE);
						break;
					case 4 : 
						img_5_back.setBackgroundColor(Color.WHITE);
						break;
				}
			}
			
			switch(index)
			{
				case 0 : 
					img_1_back.setBackgroundColor(Color.rgb(134, 28, 0));
					break;
				case 1 : 
					img_2_back.setBackgroundColor(Color.rgb(134, 28, 0));
					break;
				case 2 : 
					img_3_back.setBackgroundColor(Color.rgb(134, 28, 0));
					break;
				case 3 : 
					img_4_back.setBackgroundColor(Color.rgb(134, 28, 0));
					break;
				case 4 : 
					img_5_back.setBackgroundColor(Color.rgb(134, 28, 0));
					break;
			}
		}catch (Exception e) {
			// TODO: handle exception
		}
	}
	
	public String getPath(Uri uri) { 
	    String[] projection = { MediaStore.Images.Media.DATA }; 
	    Cursor cursor = managedQuery(uri, projection, null, null, null); 
	    int column_index = cursor 
	            .getColumnIndexOrThrow(MediaStore.Images.Media.DATA); 
	    cursor.moveToFirst(); 
	    return cursor.getString(column_index); 
	} 
	
	
		
	//ʿ   Է Ǿ üũ
	public void checkInfo()
	{
		
		final Spinner spin = (Spinner) findViewById(R.id.category);
		EditText commentEditText = (EditText) findViewById(R.id.comment);
		comment = commentEditText.getText().toString();
		selectedId = getSelectedItem(category,spin.getSelectedItem().toString());
		
		if (getImageCount() < 1)
		{
			Toast.makeText(this, " ּ", Toast.LENGTH_SHORT).show();
			return ;
		}
		if (comment.equals(""))
		{
			Toast.makeText(this, "ڸƮ Էּ", Toast.LENGTH_SHORT).show();
			return ;
		}
		
		if (selectedId == 0)
		{
			Toast.makeText(this, "error ڿ ϼ", Toast.LENGTH_SHORT).show();
			return ;
		}
		
		if (address == null)
		{
			Toast.makeText(this, "  ּ", Toast.LENGTH_SHORT).show();
			return ;
		}
		
		
		dialog = ProgressDialog.show(WriteAlbum.this, "", "...",true);
		processThread();				
		
	}
	
	public void processThread(){
		Runnable r = new Runnable() {
			public void run() {
				try{
					String res = null;		
					
					res = dbCon.insertWayPoint(comment, x, y, selectedId, address, lastAlbumID,local,imgs,1);					
					
					if (Integer.parseInt(res) > 0)
					{
						intent = new Intent(WriteAlbum.this,AlbumMapView.class);
						intent.putExtra("AlbumID", lastAlbumID);
						intent.putExtra("AlbumFlag", true);
						intent.putExtra("WaypointID", Integer.parseInt(res));
						startActivity(intent);
						finish();						 
					}		
				}catch (Exception e) {
					// TODO: handle exception
					dialog.dismiss();
				}				
			}
		};
		Thread t1 = new Thread(r);
		t1.start();
	}	
	
	//õ ׸ ̵ ...
	public Integer getSelectedItem(ArrayList<Category> category, String findText)
	{
		for (Integer i = 0 ; i < category.size() ;i++)
		{
			if (category.get(i).getName().toString().equals(findText))
			{
				return category.get(i).getId();
			}
        }
		return -1;
	}	
}
